DECLARE FUNCTION Open.Archive% (filename AS STRING)
DECLARE SUB Add.Archive (realfile AS STRING, filename AS STRING)
DECLARE FUNCTION SelectMethod% ()
DECLARE SUB Remove.Archive (num AS INTEGER)
CONST BlockSize = 1024
DECLARE SUB LZWUnCompress (infile AS STRING, outfile AS STRING)
DECLARE SUB rleUnCompress (infile AS STRING, outfile AS STRING)
DECLARE SUB RLEcompress (infile AS STRING, outfile AS STRING)
DECLARE SUB LZWcompress (infile AS STRING, outfile AS STRING)
DECLARE SUB DicoAdd (mystring AS STRING)
DECLARE SUB writeCode (Mot2%)
DECLARE FUNCTION ReadCode& ()
DECLARE SUB IncreaseDico ()
DECLARE SUB UnCompress (infile AS STRING, outfile AS STRING)
DECLARE SUB Init ()
DECLARE SUB compress (infile AS STRING, outfile AS STRING)
DECLARE FUNCTION GetCode% (w AS STRING)


DECLARE SUB Extract.Archive (num AS INTEGER, outfile AS STRING)
DECLARE SUB Load.FIleLIst ()
DECLARE SUB BlockCopy (srcHandler AS INTEGER, dstHandler AS INTEGER, bytescount AS LONG)
DECLARE SUB New.archive ()

'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\itemlist.bi'
'$INCLUDE: 'lib\locale.bi'
'$DYNAMIC

TYPE ArchiveInfo
	Tag AS STRING * 2
	MajorVersion AS INTEGER
	MinorVersion AS INTEGER
	FIlesCount AS INTEGER
	Descr AS STRING * 64
END TYPE

TYPE FileInfo
	filename AS STRING * 12
	FileSize AS LONG
	CompressionMethod AS INTEGER
END TYPE


App.SetTitle (Localize("packager.str", "txtTitle"))
App.AddMenuItem (Localize("system.str", "txtNew"))
App.AddMenuItem (Localize("system.str", "txtOpen"))
App.AddMenuItem (Localize("system.str", "txtExit"))

DIM SHARED Dico(0 TO 511) AS STRING
DIM SHARED NbrDico AS INTEGER
DIM SHARED bitSize AS INTEGER


DIM SHARED archiveFile AS STRING
DIM SHARED FileLIst(1) AS ListItem
DIM SHARED NbrFiles AS INTEGER
DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
DIM SHARED AddFIleBtn AS Button
DIM SHARED ExtractBtn AS Button
DIM SHARED ListeFile AS ItemList
DIM SHARED DeleteBtn AS Button
wx = 300
wy = 200
wx1 = (640 - wx) \ 2
wy1 = (480 - wy) \ 2
wx2 = wx1 + wx
wy2 = wy1 + wy
Initx.Button AddFIleBtn, Localize("packager.str", "txtButtonAdd"), wx1 + 5, wy1 + 20, wx1 + 100, wy1 + 40
Initx.Button DeleteBtn, Localize("system.str", "txtDelete"), wx1 + 105, wy1 + 20, wx2 - 105, wy1 + 40
Initx.Button ExtractBtn, Localize("packager.str", "txtButtonExtract"), wx2 - 100, wy1 + 20, wx2 - 5, wy1 + 40
Init.ItemLIst ListeFile, wx1 + 10, wy1 + 60, 1, 10
ListeFile.MaxWidth = 35
ListeFile.MinWidth = 35

GUI.Init
App.DrawGui
GOSUB Redraw
MouseShow
DO
	App.Manage
	GOSUB PackagerManage
	IF SelectedMenu <> "" THEN
	SELECT CASE SelectedMenu
		CASE (Localize("system.str", "txtOpen"))
			a$ = FileSelect("open", "", "")
			IF a$ <> "" THEN
				IF (Open.Archive(a$)) THEN
				Load.FIleLIst
				GOSUB Redraw
				END IF
			END IF
		CASE (Localize("system.str", "txtNew"))
			New.archive
			GOSUB Redraw
		CASE (Localize("system.str", "txtExit"))
			app.Exit
		CASE "Exit"
			app.Exit
	END SELECT
	END IF
LOOP

Redraw:
	Draw.Window wx1, wy1, wx2, wy2, Localize("packager.str", "txtTitle")
	IF archiveFile <> "" THEN
		Draw.Button AddFIleBtn
		Draw.Button ExtractBtn
		Draw.Button DeleteBtn
	IF NbrFiles > 0 THEN
		Draw.ItemList ListeFile, FileLIst()

	END IF
       
	END IF

RETURN

PackagerManage:
	IF archiveFile <> "" THEN
		IF NbrFiles > 0 THEN
			Manage.ItemList ListeFile, FileLIst()
			IF ListeFile.SelectedIndex > 0 THEN
				IF Click.Button(ExtractBtn) THEN
					a$ = FileSelect("save", "", "")
					IF a$ <> "" THEN
						Extract.Archive ListeFile.SelectedIndex, a$
					END IF
				END IF
				IF Click.Button(DeleteBtn) THEN
					Remove.Archive ListeFile.SelectedIndex
					Load.FIleLIst
					GOSUB Redraw
				END IF
			END IF
		END IF
		IF Click.Button(AddFIleBtn) THEN
			a$ = FileSelect("open", "", "")
			IF a$ <> "" THEN
				finame$ = a$
				FOR i = LEN(finame$) TO 1 STEP -1
					  IF MID$(finame$, i, 1) = "\" THEN EXIT FOR
				NEXT i
				finame$ = MID$(finame$, i + 1)
				Add.Archive a$, finame$
				Load.FIleLIst
				GOSUB Redraw
			END IF
		END IF
	END IF
RETURN

REM $STATIC
SUB Add.Archive (realfile AS STRING, filename AS STRING)
	IF archiveFile = "" THEN EXIT SUB
	SELECT CASE SelectMethod
		CASE -1
			EXIT SUB
		CASE 0
			rfile$ = realfile
			method = 0
		CASE 1
			LZWcompress realfile, "lzw.tmp"
			rfile$ = "lzw.tmp"
			method = 1
		CASE 2
			RLEcompress realfile, "rle.tmp"
			rfile$ = "rle.tmp"
			method = 2
	END SELECT
	DIM Entry AS FileInfo
	DIM fic1 AS INTEGER, fic2 AS INTEGER
	IF archiveFile = "" THEN EXIT SUB
	fic1 = FREEFILE
	DIM Header AS ArchiveInfo
	OPEN archiveFile FOR BINARY AS fic1
		GET #fic1, , Header
	CLOSE fic1
	OPEN archiveFile FOR BINARY AS fic1
	Header.FIlesCount = Header.FIlesCount + 1
	fic2 = FREEFILE
	NbrFiles = NbrFiles + 1
	PUT #fic1, , Header
	OPEN rfile$ FOR BINARY AS fic2
		Entry.FileSize = LOF(fic2)
		Entry.CompressionMethod = method
		Entry.filename = filename
		SEEK (fic1), LOF(fic1) + 1
		PUT #fic1, , Entry
		BlockCopy fic2, fic1, Entry.FileSize
	CLOSE fic2
	CLOSE fic1
	IF method = 1 THEN KILL "lzw.tmp"
	IF method = 2 THEN KILL "rle.tmp"

END SUB

SUB BlockCopy (srcHandler AS INTEGER, dstHandler AS INTEGER, bytescount AS LONG)
	DIM bytes AS LONG
	bytes = bytescount
	IF bytes > LOF(srcHandler) - SEEK(srcHandler) + 1 THEN bytes = LOF(srcHandler) - SEEK(srcHandler) + 1
	NbrBlock = bytes \ BlockSize
	rest = bytes MOD BlockSize
	FOR i = 1 TO NbrBlock
		mydata$ = SPACE$(BlockSize)
		GET #srcHandler, , mydata$
		PUT #dstHandler, , mydata$
	NEXT i
	IF rest > 0 THEN
		mydata$ = SPACE$(rest)
		GET #srcHandler, , mydata$
		PUT #dstHandler, , mydata$
	END IF
END SUB

SUB DicoAdd (mystring AS STRING)
	NbrDico = NbrDico + 1
	IF NbrDico > UBOUND(Dico) THEN IncreaseDico
	Dico(NbrDico) = mystring
END SUB

SUB Extract.Archive (num AS INTEGER, outfile AS STRING)
	IF num = 0 THEN EXIT SUB
	IF archiveFile = "" THEN EXIT SUB
	DIM fic1 AS INTEGER
	DIM fic2 AS INTEGER
	DIM NB AS INTEGER
	DIM Entry AS FileInfo
	DIM Header AS ArchiveInfo
	fic1 = FREEFILE
	OPEN archiveFile FOR BINARY AS fic1
	fic2 = FREEFILE
	OPEN outfile FOR BINARY AS fic2: CLOSE fic2: KILL outfile
	OPEN outfile FOR BINARY AS fic2
	     GET #fic1, , Header
	     NB = Header.FIlesCount
	     IF NB < num THEN
		CLOSE fic1
		CLOSE fic2
		KILL outfile
		EXIT SUB
	     END IF
	     FOR i = 1 TO num - 1
		GET #fic1, , Entry
		SEEK #fic1, SEEK(fic1) + Entry.FileSize
	     NEXT i
	     GET #fic1, , Entry
	     BlockCopy fic1, fic2, Entry.FileSize
	CLOSE fic2
	CLOSE fic1
	IF Entry.CompressionMethod = 1 THEN
		 LZWUnCompress outfile, "lzw.tmp"
		 KILL outfile
		 NAME "lzw.tmp" AS outfile
	END IF
	IF Entry.CompressionMethod = 2 THEN
		rleUnCompress outfile, "rle.tmp"
		KILL outfile
		NAME "rle.tmp" AS outfile
	END IF
END SUB

FUNCTION GetCode% (w AS STRING)
	FOR i = 0 TO NbrDico
		IF Dico(i) = w THEN
		GetCode = i
		EXIT FUNCTION
		END IF
	NEXT i
	GetCode = -1
END FUNCTION

SUB IncreaseDico
	LowBound% = LBOUND(Dico)
	OldSize% = UBOUND(Dico)
	newsize% = OldSize% + 100
	
	'saving the dico
	OPEN "dico.tmp" FOR BINARY AS 3
		FOR i = LowBound% TO OldSize%
			d% = LEN(Dico(i))
			PUT #3, , d%
			PUT #3, , Dico(i)
		NEXT i
	CLOSE 3
	'resizing the dico
	REDIM Dico(LowBound% TO newsize%)   AS STRING

	'restoring the dico data
	OPEN "dico.tmp" FOR BINARY AS 3
		FOR i = LowBound% TO OldSize%
			GET #3, , d%
			Dico(i) = STRING$(d%, " ")
			GET #3, , Dico(i)
		NEXT i
	CLOSE 3
	KILL "dico.tmp"
END SUB

SUB Init
	REDIM Dico(0 TO 511)  AS STRING
	FOR i = 0 TO 255
		Dico(i) = CHR$(i)
	NEXT i
	NbrDico = 256
	bitSize = 9
END SUB

SUB Load.FIleLIst
	IF archiveFile = "" THEN EXIT SUB
	ListeFile.SelectedIndex = 0
       
	fic = FREEFILE
	DIM Entry AS FileInfo
	DIM Header AS ArchiveInfo
	OPEN archiveFile FOR BINARY AS fic
	     GET #fic, , Header
	     NbrFiles = Header.FIlesCount
			
			IF NbrFiles < 1 THEN
				ERASE FileLIst
			ELSE
				REDIM FileLIst(1 TO NbrFiles) AS ListItem
			
				FOR i = 1 TO NbrFiles
				       
					GET #fic, , Entry
					t$ = Entry.filename
					SELECT CASE Entry.CompressionMethod
						CASE 0:
						     t$ = t$ + " (  -  )"
						CASE 1:
						     t$ = t$ + " ( LZW )"
						CASE 2:
						     t$ = t$ + " ( RLE ) "
					END SELECT
					t$ = t$ + "(" + LTRIM$(RTRIM$(STR$(Entry.FileSize))) + Localize("packager.str", "txtBytes") + ")"
					FileLIst(i).Text = t$
					FileLIst(i).Selected = 0
					SEEK #fic, SEEK(fic) + Entry.FileSize
				NEXT i
			END IF
	    
	CLOSE fic
       
END SUB

SUB LZWcompress (infile AS STRING, outfile AS STRING)
	Init
	ProgressStr$ = Localize("packager.str", "txtCompressing")
	DIM NbrBlock AS INTEGER
	DIM reste AS INTEGER
	OPEN infile FOR INPUT AS 1: CLOSE 1       'check if the input file exists
	OPEN outfile FOR BINARY AS 2: CLOSE 2: KILL outfile  'destroy the output file if exists

	DIM prefix AS STRING: prefix = ""
	DIM byte AS STRING * 1
       
	SaveScreen ("scrn")
	OPEN infile FOR BINARY AS 1
	OPEN outfile FOR BINARY AS 2
		WHILE NOT EOF(1)
			GET #1, , byte
			'ouput progression
			Progress ProgressStr$, SEEK(1) - 1, LOF(1)
			       
				'look the dictionary to find the string
				a% = GetCode(prefix + byte)

				'if it exist
				IF a% > -1 THEN
					prefix = prefix + byte
				ELSE
					'adding the new prefix to the dictionary
				       DicoAdd prefix + byte

				       'get the code from the old prefix
				       c% = GetCode(prefix)

				       'if its -1, sommething wrong happend
				       IF c% = -1 THEN
						LOCATE 6
						COLOR 4
						PRINT "Error string not found in dico"
						PRINT "DicoSize = "; NbrDico
						END
				       END IF

				       'output the code for the prefix
				       writeCode c%

				       'new prefix = readed byte
				       prefix = byte
				END IF
	       
	       WEND

	      'bugfix, before, it wrote 1 byte to much at the decompression
	      prefix = LEFT$(prefix, LEN(prefix) - 1)

	      'get the code for the prefix
	      c% = GetCode(prefix)

	      'output the code
	      writeCode c%

	      'output a code to be treated as end of file
	      writeCode 256
	CLOSE 2
	CLOSE 1
	ERASE Dico
	RestoreScreen ("scrn")
		
END SUB

SUB LZWUnCompress (infile AS STRING, outfile AS STRING)
	Init
	ProgressStr$ = Localize("packager.str", "txtUncompressing")
	DIM byte AS INTEGER
	DIM w AS STRING
	DIM entree AS STRING
	OPEN infile FOR INPUT AS 1: CLOSE 1     'check if input file exists
	OPEN outfile FOR BINARY AS 2: CLOSE 2: KILL outfile 'destroy output file if exists
	SaveScreen ("scrn")
	OPEN infile FOR BINARY AS 1
	OPEN outfile FOR BINARY AS 2
	       
		'output progression
		Progress ProgressStr$, SEEK(1) - 1, LOF(1)
	       
		'read the code
		byte = ReadCode&

		'the first byte is the first character in the decompressed file
		c$ = CHR$(byte)
		PUT #2, , c$
		w = c$


		DO
			'output progression
			Progress ProgressStr$, SEEK(1) - 1, LOF(1)

			'read the code, it will be the index of the string in the dictionary
			byte = ReadCode&
		       
			'end of file occurs
			IF byte = 256 THEN
				EXIT DO
			END IF

			'the byte represent a string
			IF (byte > 255) THEN
				'if its in the dico
				IF (byte <= NbrDico) THEN
					'get the string
					entree = Dico(byte)
				ELSE
					'usign the previous string
					entree = w + LEFT$(w, 1)
				END IF
			ELSE
			    'the byte is a normal character
			    entree = CHR$(byte)
			END IF

			'output the result to the out file
			PUT #2, , entree

			'add the entry to the dico
			DicoAdd w + LEFT$(entree, 1)

			'new string
			w = entree
		LOOP WHILE NOT EOF(1)
	CLOSE 2
	CLOSE 1
	ERASE Dico
	RestoreScreen ("scrn")
END SUB

SUB New.archive
	a$ = FileSelect("save", "", "")

	IF a$ = "" THEN EXIT SUB
	archiveFile = a$
	OPEN a$ FOR BINARY AS 1: CLOSE 1
	KILL a$
	DIM Header AS ArchiveInfo
	Header.Tag = "AR"
	Header.MajorVersion = 0
	Header.MinorVersion = 1
	Header.FIlesCount = 0
	Header.Descr = ""
	OPEN archiveFile FOR BINARY AS 1
		PUT #1, , Header
	CLOSE 1
	NbrFiles = 0
END SUB

FUNCTION Open.Archive% (filename AS STRING)
DIM Header AS ArchiveInfo
	OPEN filename FOR BINARY AS 1
		GET #1, , Header
	CLOSE 1
	IF Header.Tag <> "AR" THEN
		alert (Localize("packager.str", "txtAlertWrongformat"))
		Open.Archive% = 0
		EXIT FUNCTION
	END IF
	archiveFile = filename
	Open.Archive% = -1
END FUNCTION

FUNCTION ReadCode&
	STATIC Bit%
	STATIC N1 AS LONG
	DIM N2 AS LONG

	IF Bit% = 0 THEN a$ = "   ": GET #1, , a$: N1 = CVL(a$ + CHR$(0))
	N2 = 0
	FOR a% = 0 TO 11 STEP 1
		N2 = N2 + (N1 AND 2 ^ (a% + Bit%)) / (2 ^ Bit%)
	NEXT a%
	Bit% = -(Bit% = 0) * 12
	ReadCode& = N2

END FUNCTION

SUB Remove.Archive (num AS INTEGER)
IF archiveFile = "" THEN EXIT SUB
DIM fic AS INTEGER
DIM fic2 AS INTEGER
	fic = FREEFILE
	DIM NB AS INTEGER
	DIM Entry AS FileInfo
	DIM Header AS ArchiveInfo
	OPEN archiveFile FOR BINARY AS fic
	     GET #fic, , Header
	     NB = Header.FIlesCount
	     IF Header.FIlesCount < num THEN
		CLOSE fic
		EXIT SUB
	     END IF
	     fic2 = FREEFILE
	     OPEN "pkg.tmp" FOR BINARY AS fic2
	     Header.FIlesCount = Header.FIlesCount - 1
	     PUT #fic2, , Header
	     FOR i = 1 TO num - 1
		GET #fic, , Entry
		PUT #fic2, , Entry
		BlockCopy fic, fic2, Entry.FileSize
	     NEXT i
	     GET #fic, , Entry
	     SEEK #fic, SEEK(fic) + Entry.FileSize
	     FOR i = num + 1 TO NB
		GET #fic, , Entry
		PUT #fic2, , Entry
		BlockCopy fic, fic2, Entry.FileSize
	     NEXT i
	     CLOSE fic2
	CLOSE fic
	KILL archiveFile
	NAME "pkg.tmp" AS archiveFile
END SUB

SUB RLEcompress (infile AS STRING, outfile AS STRING)
	DIM counter AS INTEGER
	DIM char AS STRING * 1
	DIM oldbyte AS STRING * 1
	DIM outdata AS STRING
	SaveScreen ("scrn")
	fic = FREEFILE
	OPEN infile FOR INPUT AS fic: fic2 = FREEFILE: CLOSE fic  'check if input file exists
	OPEN outfile FOR BINARY AS fic2: CLOSE fic2: KILL outfile 'destroy output file if exists
	SaveScreen ("scrn")
	ProgressStr$ = Localize("packager.str", "txtCompressingRLE")
	OPEN infile FOR BINARY AS fic
	OPEN outfile FOR BINARY AS fic2

	NbrBlock = (LOF(fic) - 1) \ BlockSize
	rest = (LOF(fic) - 1) MOD BlockSize
	DIM index AS LONG: index = 0
	GET #fic, , char
	oldbyte = char
	outdata = ""
	counter = 1
	WHILE NOT EOF(fic)
		Progress ProgressStr$, SEEK(fic), LOF(fic)
		GET #fic, , char
		IF char <> oldbyte THEN
			d$ = CHR$(counter)
			PUT #fic2, , d$
			PUT #fic2, , oldbyte
			oldbyte = char
			counter = 1
		ELSE
			counter = counter + 1
			IF counter > 255 THEN
			  d$ = CHR$(255)
			  PUT #fic2, , d$
			  PUT #fic2, , oldbyte
			  counter = 1
			END IF
		END IF

	WEND
	CLOSE fic2
	CLOSE fic

	RestoreScreen ("scrn")
END SUB

SUB rleUnCompress (infile AS STRING, outfile AS STRING)
	SaveScreen ("scrn")
	fic = FREEFILE
	ProgressStr$ = Localize("packager.str", "txtUncompressingRLE")
	OPEN infile FOR INPUT AS fic: fic2 = FREEFILE: CLOSE fic    'check if the input file exists
	OPEN outfile FOR BINARY AS fic2: CLOSE fic2: KILL outfile  'destroy the output file if exists
	OPEN infile FOR BINARY AS fic
	DIM index AS LONG: index = 0
	OPEN outfile FOR BINARY AS fic2
		WHILE NOT EOF(fic)
			m$ = " ": n$ = " "
			GET #fic, , m$
			GET #fic, , n$
			t$ = STRING$(ASC(m$), n$)
			PUT #fic2, , t$
			Progress ProgressStr$, SEEK(fic), LOF(fic)
			l& = l& + ASC(m$)
		WEND
	CLOSE fic2
	CLOSE fic
'        alert ("File size:" + STR$(l&))
	RestoreScreen ("scrn")
END SUB

FUNCTION SelectMethod%
	DIM SelectList AS ItemList
	DIM MethodList(0 TO 2) AS ListItem
	DIM OkBtn AS Button
	DIM CancelBtn AS Button
	MethodList(0).Text = Localize("packager.str", "txtMethodStore")
	MethodList(1).Text = Localize("packager.str", "txtMethodLZW")
	MethodList(2).Text = Localize("packager.str", "txtMethodRLE")
	MethodList(0).Selected = -1
	MethodList(1).Selected = 0
	MethodList(2).Selected = 0
	
	sx% = 140
	sy% = 120
	sx1% = (640 - sx%) \ 2
	sx2% = sx1% + sx%
	sy1% = (480 - sy%) \ 2
	sy2% = sy1% + sy%
	Initx.Button OkBtn, Localize("system.str", "txtOk"), sx1% + 10, sy2% - 30, 315, sy2% - 10
	Initx.Button CancelBtn, Localize("system.str", "txtCancel"), 325, sy2% - 30, sx2% - 10, sy2% - 10
	Init.ItemLIst SelectList, sx1% + 7, sy1% + 30, 1, 5
	SelectList.SelectedIndex = 0
	SelectList.MinWidth = 15
	SelectList.MaxWidth = 15

	SaveScreen ("method")
	Draw.Window sx1%, sy1%, sx2%, sy2%, Localize("packager.str", "txtMethodSelect")
	Draw.ItemList SelectList, MethodList()
	Draw.Button OkBtn
	Draw.Button CancelBtn
	DO
		Manage.ItemList SelectList, MethodList()
		IF Click.Button(OkBtn) THEN
			result = SelectList.SelectedIndex
			EXIT DO
		END IF
		IF Click.Button(CancelBtn) THEN
			result = -1
			EXIT DO
		END IF
	LOOP
	
	RestoreScreen ("method")
	SelectMethod = result
END FUNCTION

SUB writeCode (Mot2%)
DIM n AS LONG
STATIC Mot1%

  IF Mot1% = 0 THEN
	IF Mot2% = 256 THEN
		c$ = CHR$(0) + CHR$(1)
		PUT #2, , c$
		EXIT SUB
	ELSE
		Mot1% = Mot2% + 1
		EXIT SUB
	END IF
  ELSE
    n = (Mot1% - 1) + Mot2% * (2 ^ 12)
    c$ = ""
    FOR a = 0 TO 2
      c$ = c$ + CHR$((n AND (255 * 2 ^ (a * 8))) / 2 ^ (a * 8))
    NEXT a
    PUT #2, , c$
    Mot1% = 0
  END IF
 

END SUB

