DECLARE FUNCTION GetOpt$ (akey AS STRING)
DECLARE FUNCTION FindOpt! (myoption AS STRING)

'$INCLUDE: 'lib\pkglib.bi'

CLS
IF FindOpt("-L") THEN GOSUB getList
IF FindOpt("-C") THEN GOSUB Create
IF FindOpt("-A") THEN GOSUB AddFile
IF FindOpt("-E") THEN GOSUB ExtractFile
IF FindOpt("-D") THEN GOSUB SaveDir
IF FindOpt("-X") THEN GOSUB ExtractAll
IF FindOpt("-R") THEN GOSUB Remove
help:
	PRINT "Archive utility"
	PRINT "Usage:"
	PRINT "pkgutil.exe -h : show this help"
	PRINT "pkgutil.exe -l archive=ArchiveFile : show the list of files in the archive"
	PRINT "pkgutil.exe -a archive=ArchiveFile file=filename method=number"
	PRINT "       where :"
	PRINT "          ArchiveFile is the archive where to add the file"
	PRINT "          filename is the file to add"
	PRINT "          number is the number of the compression method (0=store,1=LZW,2=RLE)"
	PRINT "       if number is missing, store is used"
	PRINT "       if the archive dont exist, it will be created"
	PRINT "pkgutil.exe -e archive=ArchiveFIle num=number file=filename"
	PRINT "       where :"
	PRINT "          ArchiveFile is the archive to extract the file from"
	PRINT "          filename is the file to write"
	PRINT "          number is the number of the file to extract"
	PRINT "pkgutil.exe -r archive=ArchiveFile num=numter"
	PRINT "       where:"
	PRINT "          ArchiveFile is the archive where i delete the file"
	PRINT "          number is the number of the file to delete"
	PRINT "pkgutil.exe -d archive=ArchiveFile directory=path"
	PRINT "       where :"
	PRINT "          ArchiveFile is the archive to create"
	PRINT "          path is the directory to store in the archive"
	PRINT "       it will create an archive, and add all file in the directory into the archive"
	PRINT "       it dont save the sub-directory"
	PRINT "pkgutil.exe -x archive=ArchiveFile [directory=path]"
	PRINT "       where :"
	PRINT "          ArchiveFile is the archive to extract"
	PRINT "          path is the directory where to save the files"
	PRINT "       if no path is specified, the current directory is used"

END

getList:
	a$ = GetOpt$("archive")
	IF a$ = "" THEN GOSUB help
	Archive.List a$
       
END

AddFile:
	Archive$ = GetOpt$("archive")
	IF Archive$ = "" THEN GOSUB help
	FileName$ = GetOpt$("file")
	IF FileName$ = "" THEN GOSUB help
	Method% = VAL(GetOpt$("method"))
	Archive.Add Archive$, FileName$, "", Method%
END

Create:
	Archive$ = GetOpt$("archive")
	IF Archive$ = "" THEN GOSUB help
	Archive.Create Archive$
RETURN

ExtractFile:
	Archive$ = GetOpt$("archive")
	IF Archive$ = "" THEN GOSUB help
	FileName$ = GetOpt$("file")
	IF FileName$ = "" THEN GOSUB help
	number% = VAL(GetOpt$("num"))
	IF number% = 0 THEN GOSUB help
	Archive.Extract Archive$, number%, FileName$

END

SaveDir:
	Archive$ = GetOpt$("archive")
	IF Archive$ = "" THEN GOSUB help
	directory$ = GetOpt$("directory")
	IF directory$ = "" THEN GOSUB help
	Archive.ArchiveDirectory directory$, Archive$
END

ExtractAll:
	Archive$ = GetOpt$("archive")
	IF Archive$ = "" THEN GOSUB help
	directory$ = GetOpt$("directory")
	IF directory$ = "" THEN
		SHELL "cd>dir.tmp"
		OPEN "dir.tmp" FOR INPUT AS 1
			INPUT #1, directory$
		CLOSE 1
		KILL "dir.tmp"
	END IF
	Archive.ExtractAll Archive$, directory$

END

Remove:
	Archive$ = GetOpt$("archive")
	IF Archive$ = "" THEN GOSUB help
	number% = VAL(GetOpt$("num"))
	IF number% = 0 THEN GOSUB help
	Archive.Remove Archive$, number%

END

FUNCTION FindOpt (myoption AS STRING)
	   FOR i = 1 TO LEN(COMMAND$) - (LEN(myoption) - 1)
		IF MID$(COMMAND$, i, LEN(myoption)) = myoption THEN
			IF i = 1 THEN FindOpt = -1: EXIT FUNCTION
			IF MID$(COMMAND$, i - 1, 1) = " " THEN FindOpt = -1: EXIT FUNCTION
		END IF
	   NEXT i
END FUNCTION

FUNCTION GetOpt$ (akey AS STRING)
	t$ = ""
	i = INSTR(UCASE$(COMMAND$), UCASE$(akey) + "=")
	IF (i > 0) AND (i + LEN(akey)) < LEN(COMMAND$) THEN
	  t$ = MID$(COMMAND$, i + LEN(akey) + 1)
	  IF LEFT$(t$, 1) = CHR$(34) THEN
		FOR i = 2 TO LEN(t$)
		  IF MID$(t$, i, 1) = CHR$(34) THEN
			t$ = MID$(LEFT$(t$, i - 1), 2)
			EXIT FOR
		  END IF
		NEXT i
	  ELSE
		  FOR i = 1 TO LEN(t$)
			IF MID$(t$, i, 1) = " " THEN
			  t$ = LEFT$(t$, i - 1)
			  EXIT FOR
			END IF
		  NEXT i
	  END IF
	END IF
	GetOpt$ = UCASE$(t$)

END FUNCTION

