DECLARE SUB Sort ()
DECLARE FUNCTION DateVal& (Day%, Month%, Year%, Hour%, Minuts%)
DECLARE SUB Load.RdvDay (Day%, Month%, Year%)
DECLARE SUB draw.DayView ()
DECLARE SUB Manage.DayView ()
CONST CalendarView = 1
CONST DayView = 2
CONST LeftArrow = 75
CONST RightArrow = 77
CONST MAJLeftArrow = 115
CONST MAJRightArrow = 116

DECLARE SUB Load.RdvMonth (Month%, Year%)
DECLARE SUB Manage.CalendarView ()
DECLARE SUB Draw.CalendarView ()
DECLARE FUNCTION NbrDayOfYear% (Year AS INTEGER)
DECLARE FUNCTION DayOfWeek% (Day%, Month%, Year%)
DECLARE FUNCTION NbrDayOfMOnth% (Month AS INTEGER, Year AS INTEGER)

'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\net.bi'
'$INCLUDE: 'lib\locale.bi'

TYPE RDV
	Day AS INTEGER
	Month AS INTEGER
	Year AS INTEGER
	Hour AS INTEGER
	Minuts AS INTEGER
	Title AS STRING * 100
	Adress AS STRING * 100
	DurationHour AS INTEGER
	DurationMinut AS INTEGER
END TYPE
'$DYNAMIC
ON ERROR GOTO catch
DIM SHARED AddRdvBtn AS Button
DIM SHARED GlobalKey AS STRING
DIM SHARED NextMonthBtn AS Button
DIM SHARED PrevMonthBtn AS Button
DIM SHARED NextYearBtn AS Button
DIM SHARED PrevYearBtn AS Button
DIM SHARED BackBtn AS Button
DIM SHARED CurrentMonth AS INTEGER
DIM SHARED CurrentYear AS INTEGER
DIM SHARED CurrentDay AS INTEGER
DIM SHARED FirstDayOfMonth AS INTEGER
DIM SHARED MOnthStr(1 TO 12) AS STRING
DIM SHARED DayStr(1 TO 7) AS STRING
DIM SHARED addBtn(1 TO 31) AS Button
DIM SHARED CurrentNbrDay AS INTEGER
DIM SHARED NbrRdv AS INTEGER
DIM SHARED RDVs(1) AS RDV
DIM SHARED CurrentView AS INTEGER

MOnthStr(1) = Localize("Calendar.str", "txtMonthJan")
MOnthStr(2) = Localize("Calendar.str", "txtMonthFeb")
MOnthStr(3) = Localize("Calendar.str", "txtMonthMar")
MOnthStr(4) = Localize("Calendar.str", "txtMonthApr")
MOnthStr(5) = Localize("Calendar.str", "txtMonthMay")
MOnthStr(6) = Localize("Calendar.str", "txtMonthJun")
MOnthStr(7) = Localize("Calendar.str", "txtMonthJul")
MOnthStr(8) = Localize("Calendar.str", "txtMonthAug")
MOnthStr(9) = Localize("Calendar.str", "txtMonthSep")
MOnthStr(10) = Localize("Calendar.str", "txtMonthOct")
MOnthStr(11) = Localize("Calendar.str", "txtMonthNov")
MOnthStr(12) = Localize("Calendar.str", "txtMonthDec")
DayStr(1) = Localize("Calendar.str", "txtDayMon")
DayStr(2) = Localize("Calendar.str", "txtDayTue")
DayStr(3) = Localize("Calendar.str", "txtDayWed")
DayStr(4) = Localize("Calendar.str", "txtDayThu")
DayStr(5) = Localize("Calendar.str", "txtDayFri")
DayStr(6) = Localize("Calendar.str", "txtDaySat")
DayStr(7) = Localize("Calendar.str", "txtDaySun")

CurrentDay = 0
CurrentMonth = 0
CurrentYear = 0
OPEN "cmdline" FOR INPUT AS 1
       INPUT #1, CurrentDay
       INPUT #1, CurrentMonth
       INPUT #1, CurrentYear
CLOSE 1
Dview = 0
KILL "cmdline"
IF CurrentDay = 0 OR CurrentMonth = 0 OR CurrentYear = 0 THEN
	CurrentMonth = VAL(LEFT$(DATE$, 2))
	CurrentDay = VAL(MID$(DATE$, 4, 2))
	CurrentYear = VAL(RIGHT$(DATE$, 4))
ELSE
	Dview = -1
END IF

Initx.Button PrevYearBtn, "<<", 10, 20, 35, 45
Initx.Button NextYearBtn, ">>", 604, 20, 629, 45
Initx.Button PrevMonthBtn, "<", 40, 20, 65, 45
Initx.Button NextMonthBtn, ">", 574, 20, 599, 45




App.SetTitle ("Planner")
App.AddMenuItem (Localize("System.str", "txtExit"))

GUI.Init
App.DrawGui
IF Dview THEN
	draw.DayView
ELSE
	Draw.CalendarView
END IF
MouseShow
DO
	SelectedMenu = ""
	GlobalKey = INKEY$
	App.ManageKey GlobalKey
	IF SelectedMenu <> "" THEN
	SELECT CASE SelectedMenu
		CASE "Exit"
			App.Exit
		CASE Localize("System.str", "txtExit"):
			App.Exit
	END SELECT
	END IF
	IF CurrentView = CalendarView THEN Manage.CalendarView
	IF CurrentView = DayView THEN Manage.DayView
LOOP


catch:
	RESUME NEXT

REM $STATIC
FUNCTION DateVal& (Day%, Month%, Year%, Hour%, Minuts%)
	D& = ((Year% - 2000))
	D& = (D& * 366)'
	D& = D& + (Month% * 12) + Day%
	D& = D& * 24
	D& = D& + Hour%
	D& = D& * 60
	D& = D& + Minuts%
	DateVal& = D&
END FUNCTION

FUNCTION DayOfWeek% (Day%, Month%, Year%)
	century% = (Year% - (Year% MOD 100)) / 100
	FirstDay% = 6 - (century% MOD 4) * 2
	DIM Mt(1 TO 12)  AS INTEGER
       
	Mt(1) = 0: Mt(2) = 3: Mt(3) = 3: Mt(4) = 6: Mt(5) = 1: Mt(6) = 4
	Mt(7) = 6: Mt(8) = 2: Mt(9) = 5: Mt(10) = 0: Mt(11) = 3: Mt(12) = 5


	iYear% = Year% - (century% * 100)
	iInt% = iYear% \ 4
	iMonth% = Mt(Month%)
	IF (NbrDayOfYear(Year%) = 366) AND (Month% < 3) THEN iMonth% = ((iMonth% + 7) - 1) MOD 7
	       
	iAdd% = FirstDay% + iYear% + iInt% + iMonth% + Day%
	iRemainder% = iAdd% MOD 7
	IF iRemainder% = 0 THEN iRemainder% = 7
	DayOfWeek% = iRemainder% - 1
END FUNCTION

SUB Draw.CalendarView
	Load.RdvMonth CurrentMonth, CurrentYear
	MouseHide
	LINE (5, 17)-(635, 460), BgColor, BF
	amonthstr$ = MOnthStr(CurrentMonth) + STR$(CurrentYear)
	tx1% = (640 - (LEN(amonthstr$) * 8)) \ 2
	Draw.Text amonthstr$, tx1%, 30, TextColor, BgColor
	FOR i = 1 TO 7
		x% = 30 + (i - 1) * 90
		Draw.Text DayStr(i), x%, 50, TextColor, BgColor
	NEXT i
	CurrentNbrDay = NbrDayOfMOnth(CurrentMonth, CurrentYear)
	iy = 0
	ix = DayOfWeek(1, CurrentMonth, CurrentYear)
	FOR i% = 1 TO CurrentNbrDay
		ix1% = 5 + (ix * 90)
		iy1% = 70 + (iy * 65)
		TC% = TextColor
		Bc% = BgColor
		Draw.Frame ix1%, iy1%, ix1% + 90, iy1% + 65
		isRDV = 0
		FOR j = 1 TO NbrRdv
			isRDV = (RDVs(j).Day = i%) AND (RDVs(j).Month = CurrentMonth) AND (RDVs(j).Year = CurrentYear)
			IF isRDV THEN EXIT FOR
		NEXT j
		IF isRDV THEN
			TC% = SelectTextColor
			Bc% = SelectBgColor
			LINE (ix1% + 1, iy1% + 1)-(ix1% + 88, iy1% + 63), Bc%, BF
		END IF
		Draw.Text LTRIM$(STR$(i%)), ix1% + 5, iy1% + 5, TC%, Bc%
		Initx.Button addBtn(i%), "+", ix1% + 70, iy1% + 5, ix1% + 85, iy1% + 20
		Draw.Button addBtn(i%)
		ix = ix + 1
		IF ix > 6 THEN ix = 0: iy = iy + 1
	       
	NEXT i%

	Draw.Button NextMonthBtn
	Draw.Button NextYearBtn
	Draw.Button PrevMonthBtn
	Draw.Button PrevYearBtn
       CurrentView = CalendarView
       MouseShow

END SUB

SUB draw.DayView
	Load.RdvDay CurrentDay, CurrentMonth, CurrentYear
	MouseHide
	LINE (5, 17)-(635, 460), BgColor, BF
	adaystr$ = STR$(CurrentDay) + " " + MOnthStr(CurrentMonth) + STR$(CurrentYear)
	tx1% = (640 - (LEN(adaystr$) * 8)) \ 2
	Draw.Text adaystr$, tx1%, 30, TextColor, BgColor
	Initx.Button BackBtn, Localize("Calendar.str", "txtBackCalendar"), 10, 25, 180, 50
	Initx.Button AddRdvBtn, Localize("Calendar.str", "txtNewAppointment"), 460, 25, 630, 50
	Draw.Button AddRdvBtn
	Draw.Button BackBtn
	h% = 30
	Draw.Frame 10, 60, 630, 450
	LINE (66, 61)-(628, 448), 7, BF
	FOR i = 8 TO 20
		x1% = 10
		y1% = 60 + (i - 8) * h%
 '               LINE (x1%, y1%)-(x1% + 55, y1% + h%), 9, B
		Draw.Frame x1%, y1%, x1% + 55, y1% + h%
		Draw.Text LTRIM$(STR$(i)) + ":00", x1% + 3, y1% + 3, 9, BgColor
	NEXT i
	FOR i = 1 TO NbrRdv
		x1% = 65
		y = RDVs(i).Hour + RDVs(i).Minuts / 60
		y1% = 60 + (y - 8) * h%
		hei = RDVs(i).DurationHour + RDVs(i).DurationMinut / 60
		y2% = y1% + (hei * h%)
		IF y2% < y1% + 30 THEN y2% = y1% + 30
		x2% = 630
		Draw.Frame x1%, y1%, x2%, y2%
		
		EndHour = RDVs(i).Hour + RDVs(i).DurationHour
		EndMinut = RDVs(i).Minuts + RDVs(i).DurationMinut

		IF EndMinut > 59 THEN
			WHILE EndMinut > 59
				EndHour = EndHour + EndMinut \ 60
				EndMinut = EndMinut MOD 60
			WEND
		END IF
		sH$ = LTRIM$(STR$(RDVs(i).Hour))
		sM$ = LTRIM$(STR$(RDVs(i).Minuts))
		IF LEN(sH$) < 2 THEN sH$ = "0" + sH$
		IF LEN(sM$) < 2 THEN sM$ = "0" + sM$
		t$ = "From " + sH$ + ":" + sM$
		sH$ = LTRIM$(STR$(EndHour))
		sM$ = LTRIM$(STR$(EndMinut))
		IF LEN(sH$) < 2 THEN sH$ = "0" + sH$
		IF LEN(sM$) < 2 THEN sM$ = "0" + sM$
		t$ = t$ + " TO " + sH$ + ":" + sM$
		Draw.Text t$, x1% + 2, y1% + 2, TextColor, BgColor
		Draw.Text LTRIM$(RTRIM$(RDVs(i).Title)), x1% + 2, y1% + 10, 4, BgColor
		t$ = LTRIM$(RTRIM$(RDVs(i).Adress))
		xl = LEN(t$) * 8
		Draw.Text t$, x2% - xl - 2, y2% - 10, 9, BgColor

	NEXT i

	MouseShow
	CurrentView = DayView

END SUB

SUB Load.RdvDay (Day%, Month%, Year%)
	fic = FREEFILE
	DIM Entry AS RDV
	OPEN "system\planer.dat" FOR BINARY AS fic
	      NRdv = LOF(fic) \ LEN(RDVs(1))
	      NbrRdv = 0
		FOR i = 1 TO NRdv
		    GET #fic, , Entry
		    IF Entry.Day = Day% AND Entry.Month = Month% AND Entry.Year = Year% THEN NbrRdv = NbrRdv + 1
		NEXT i
	CLOSE fic

	IF NbrRdv = 0 THEN
		REDIM RDVs(1 TO 1) AS RDV
		EXIT SUB
	END IF
	REDIM RDVs(1 TO NbrRdv) AS RDV
	index = 1
	OPEN "system\planer.dat" FOR BINARY AS fic
		FOR i = 1 TO NRdv
			GET #fic, , Entry
			IF Entry.Day = Day% AND Entry.Month = Month% AND Entry.Year = Year% THEN
				RDVs(index) = Entry
				index = index + 1
			END IF
		NEXT i
	CLOSE fic
	Sort
END SUB

SUB Load.RdvMonth (Month%, Year%)
	fic = FREEFILE
	DIM Entry AS RDV
	OPEN "system\planer.dat" FOR BINARY AS fic
	      NRdv = LOF(fic) \ LEN(RDVs(1))
	      NbrRdv = 0
		FOR i = 1 TO NRdv
		    GET #fic, , Entry
		    IF Entry.Month = Month% AND Entry.Year = Year% THEN NbrRdv = NbrRdv + 1
		NEXT i
	CLOSE fic

	IF NbrRdv = 0 THEN
		REDIM RDVs(1 TO 1) AS RDV
		EXIT SUB
	END IF
	REDIM RDVs(1 TO NbrRdv) AS RDV
	index = 1
	OPEN "system\planer.dat" FOR BINARY AS fic
		FOR i = 1 TO NRdv
			GET #fic, , Entry
			IF Entry.Month = Month% AND Entry.Year = Year% THEN
				RDVs(index) = Entry
				index = index + 1
			END IF
		NEXT i
	CLOSE fic
END SUB

SUB Manage.CalendarView
     IF (CurrentMonth <> 1) OR (CurrentYear > 1700) THEN
     IF Click.Button(PrevMonthBtn) OR (GlobalKey = CHR$(0) + CHR$(LeftArrow)) THEN
	CurrentMonth = CurrentMonth - 1
	IF CurrentMonth < 1 THEN : CurrentMonth = 12: CurrentYear = CurrentYear - 1
	Draw.CalendarView
     END IF
     END IF
     IF (CurrentMonth <> 12) OR (CurrentYear < 2699) THEN
     IF Click.Button(NextMonthBtn) OR (GlobalKey = CHR$(0) + CHR$(RightArrow)) THEN
	CurrentMonth = CurrentMonth + 1
	IF CurrentMonth > 12 THEN : CurrentMonth = 1: CurrentYear = CurrentYear + 1
	Draw.CalendarView
     END IF
     END IF
     IF (CurrentYear > 1700) THEN
     IF Click.Button(PrevYearBtn) OR (GlobalKey = CHR$(0) + CHR$(MAJLeftArrow)) THEN
	CurrentYear = CurrentYear - 1
	Draw.CalendarView
     END IF
     END IF
     IF CurrentYear < 2699 THEN
     IF Click.Button(NextYearBtn) OR (GlobalKey = CHR$(0) + CHR$(MAJRightArrow)) THEN
       CurrentYear = CurrentYear + 1
       Draw.CalendarView
     END IF
     END IF
	ix = DayOfWeek(1, CurrentMonth, CurrentYear)
	FOR i% = 1 TO CurrentNbrDay
		IF Click.Button(addBtn(i%)) THEN
		      Exec.Module ("addrdv.exe d=" + LTRIM$(STR$(i%)) + "m=" + LTRIM$(STR$(CurrentMonth)) + "y=" + LTRIM$(STR$(CurrentYear)))
			Draw.CalendarView
		END IF
		ix1% = 5 + (ix * 90)
		iy1% = 70 + (iy * 65)
		IF (MouseZOne(ix1%, iy1%, ix1% + 90, iy1% + 65) AND MouseClicLeft) AND NOT (MouseZOne(addBtn(i%).x1, addBtn(i%).y1, addBtn(i%).x2, addBtn(i%).y2)) THEN
			DO: LOOP UNTIL NOT ((MouseZOne(ix1%, iy1%, ix1% + 90, iy1% + 65) AND MouseClicLeft))
			IF MouseZOne(ix1%, iy1%, ix1% + 90, iy1% + 65) THEN
				CurrentDay = i%
				draw.DayView
		      
			END IF
		END IF
		ix = ix + 1
		IF ix > 6 THEN ix = 0: iy = iy + 1
       NEXT i%
END SUB

SUB Manage.DayView
	IF Click.Button(AddRdvBtn) THEN
		      Exec.Module ("addrdv.exe d=" + LTRIM$(STR$(CurrentDay)) + "m=" + LTRIM$(STR$(CurrentMonth)) + "y=" + LTRIM$(STR$(CurrentYear)))
			draw.DayView

	END IF
	IF Click.Button(BackBtn) OR GlobalKey = CHR$(8) THEN
	      Draw.CalendarView
	END IF
	IF (GlobalKey = CHR$(0) + CHR$(LeftArrow)) THEN
		CurrentDay = CurrentDay - 1
		IF CurrentDay < 1 THEN
			CurrentMonth = CurrentMonth - 1
			IF CurrentMonth < 1 THEN
				CurrentMonth = 12
				CurrentYear = CurrentYear - 1
			END IF
			CurrentDay = NbrDayOfMOnth(CurrentMonth, CurrentYear)
		END IF
		draw.DayView
	END IF
	IF GlobalKey = CHR$(0) + CHR$(RightArrow) THEN
		CurrentDay = CurrentDay + 1
		IF CurrentDay > CurrentNbrDay THEN
			CurrentDay = 1
			CurrentMonth = CurrentMonth + 1
			IF CurrentMonth > 12 THEN
				CurrentMonth = 1
				CurrentYear = CurrentYear + 1
			END IF
		END IF
		draw.DayView
	END IF

END SUB

FUNCTION NbrDayOfMOnth% (Month AS INTEGER, Year AS INTEGER)
	IF ((Month + ABS(Month > 7)) MOD 2) = 1 THEN
		NbrDayOfMOnth% = 31
	ELSE
		IF Month <> 2 THEN
		   NbrDayOfMOnth% = 30
		ELSE
			IF (((Year MOD 4) = 0) AND (NOT ((Year MOD 100) = 0))) OR ((Year MOD 400) = 0) THEN
				NbrDayOfMOnth% = 29
			ELSE
				NbrDayOfMOnth% = 28
			END IF
		END IF
	END IF

END FUNCTION

FUNCTION NbrDayOfYear% (Year AS INTEGER)
			IF (((Year MOD 4) = 0) AND (NOT ((Year MOD 100) = 0))) OR ((Year MOD 400) = 0) THEN
				NbrDayOfYear% = 366
			ELSE
				NbrDayOfYear% = 365
			END IF
END FUNCTION

SUB Sort
	FOR i = LBOUND(RDVs) TO UBOUND(RDVs) - 1
		FOR j = 1 TO UBOUND(RDVs) - i
		  a& = DateVal(RDVs(j).Day, RDVs(j).Month, RDVs(j).Day, RDVs(j).Hour, RDVs(j).Minuts)
		  B& = DateVal(RDVs(j + 1).Day, RDVs(j + 1).Month, RDVs(j + 1).Day, RDVs(j + 1).Hour, RDVs(j + 1).Minuts)
		  IF a& > B& THEN SWAP RDVs(j), RDVs(j + 1)
		NEXT j
	NEXT i
END SUB

