DECLARE FUNCTION RemoveTags$ (text AS STRING)
DECLARE SUB RemoveBookMark (num AS INTEGER)
DECLARE FUNCTION GetBookMarkUrl$ (num AS INTEGER)
DECLARE SUB SaveBookMark (url AS STRING, title AS STRING)
DECLARE SUB DrawBookMark ()
DECLARE SUB LoadBookMark ()
DECLARE SUB LoadRss (url AS STRING)
DECLARE SUB GetRss (url AS STRING)
DECLARE FUNCTION GetArticle$ (filename AS STRING, num AS INTEGER)
DECLARE FUNCTION GetTitle$ (filename AS STRING, num AS INTEGER)
DECLARE FUNCTION GetNbrArticles! (filename AS STRING)
DECLARE SUB Net.DownloadPageNoPost (url AS STRING, OutputFile AS STRING)
'$INCLUDE: 'lib\guilib.bi'
'$INCLUDE: 'lib\mouse.bi'
'$INCLUDE: 'lib\modules.bi'
'$INCLUDE: 'lib\textbox.bi'
'$INCLUDE: 'lib\app.bi'
'$INCLUDE: 'lib\reg.bi'
'$INCLUDE: 'lib\net.bi'
'$INCLUDE: 'lib\multline.bi'
'$INCLUDE: 'lib\itemlist.bi'
'$INCLUDE: 'lib\locale.bi'
'$DYNAMIC
TYPE RssBookMark
	title AS STRING * 50
	url AS STRING * 100
END TYPE


IF VAL(RegRead("Network:Enabled")) <> 1 THEN
	GUI.Init
	MouseShow
	Alert (Localize("System.str", "txtNetworkNotEnabled"))
	app.exit
END IF

DIM SHARED BookMarkList AS ItemList
DIM SHARED BookMarkText(1) AS ListItem
DIM SHARED nbrBookMark AS INTEGER
DIM SHARED getBookMarkBtn AS button
DIM SHARED RemoveBookMarkBtn AS button
ON ERROR GOTO catch
DIM SHARED rep AS INTEGER
DIM SHARED wx1 AS INTEGER, wy1 AS INTEGER, wx2 AS INTEGER, wy2 AS INTEGER
DIM UrlTxt AS TextBox
DIM GoBtn AS button
DIM BookMarkBtn AS button
DIM SHARED NbrArticles AS INTEGER
DIM ListeArticles AS ItemList
DIM SHARED ArticlesData(1) AS ListItem
DIM ArticleContent AS MultiLine
DIM SHARED ArticleText AS STRING
DIM SHARED RssUrl AS STRING
DIM SHARED RssTitle AS STRING
DIM SHARED bx1 AS INTEGER, by1 AS INTEGER, bx2 AS INTEGER, by2 AS INTEGER
wx = 398
wy = 395
wx1 = (640 - wx) - 10
wy1 = (495 - wy) / 2
wx2 = wx1 + wx - 1
wy2 = wy1 + wy - 1
bx1 = 10: by1 = wy1: bx2 = wx1 - 20: by2 = wy2


App.SetTitle (Localize("rss.str", "txtTitle"))
App.AddMenuItem (Localize("system.str", "txtExit"))
Init.TextBox UrlTxt, wx1 + 5, wy1 + 7, 37


Initx.Button GoBtn, Localize("rss.str", "txtGetit"), wx2 - 75, wy1 + 5, wx2 - 5, wy1 + 20
Initx.Button getBookMarkBtn, Localize("rss.str", "txtGetit"), bx1 + 5, by2 - 20, bx2 - 5, by2 - 5
Initx.Button RemoveBookMarkBtn, Localize("rss.str", "txtRemove"), bx1 + 5, by2 - 40, bx2 - 5, by2 - 25
Initx.Button BookMarkBtn, Localize("rss.str", "txtBookmark"), wx2 - 100, wy1 + 25, wx2 - 5, wy1 + 40
Init.ItemLIst ListeArticles, wx1 + 5, wy1 + 55, 1, 11
Init.ItemLIst BookMarkList, bx1 + 7, by1 + 20, 1, 30

Init.MultiLine ArticleContent, wx1 + 5, wy1 + 185, 46, 25
ArticleContent.ReadOnly = -1

ListeArticles.MinWIdth = 48
ListeArticles.MaxWidth = 48
BookMarkList.MinWIdth = 23
BookMarkList.MaxWidth = 23

LoadBookMark

GUI.Init
SelectedArticle% = 0
App.DrawGui
Draw.Window wx1, wy1 - 15, wx2, wy2, Localize("rss.str", "txtTitle")

Draw.TextBox UrlTxt
Draw.Button GoBtn
Draw.Button BookMarkBtn
Draw.MUltiLIne ArticleContent, ArticleText

MouseShow
DrawBookMark
DO
	App.Manage
	IF RssUrl <> "" THEN
		IF Click.Button(BookMarkBtn) THEN
			SaveBookMark RssUrl, RssTitle
		END IF
	END IF
	Manage.TextBox UrlTxt
	IF UrlTxt.TextLen > 0 THEN
		IF Click.Button(GoBtn) THEN
			SelectedArticle% = 0
			ArticleText = ""
			u$ = LTRIM$(RTRIM$(UrlTxt.text))
			LoadRss (u$)
			
			IF NbrArticles > 0 THEN
				Draw.ItemList ListeArticles, ArticlesData()
			ELSE
				MouseHide
				LINE (wx1 + 5, wy1 + 25)-(wx2, wy2 - 5), 8, BF
				MouseShow
			END IF
			ArticleText = ""
			Draw.MUltiLIne ArticleContent, ArticleText
		END IF
	END IF
	IF SelectedMenu <> "" THEN
	SELECT CASE SelectedMenu
		CASE "Exit"
			KILL "out.xml"
			app.exit
		CASE Localize("system.str", "txtExit")
			KILL "out.xml"
			app.exit
	END SELECT
	END IF
	IF NbrArticles > 0 THEN
		Manage.ItemList ListeArticles, ArticlesData()
		IF ListeArticles.SelectionChanged THEN
			SelectedArticle% = ListeArticles.SelectedIndex
			ArticleText = GetArticle("out.xml", SelectedArticle%)
			ArticleContent.FIrstLine = -(1024)
			Draw.MUltiLIne ArticleContent, ArticleText
		END IF
	END IF
	IF SelectedArticle% <> 0 THEN Manage.MultiLIne ArticleContent, ArticleText
	IF nbrBookMark > 0 THEN
		Manage.ItemList BookMarkList, BookMarkText()
		IF LTRIM$(RTRIM$(BookMarkList.SelectedText)) <> "" THEN
		      IF Click.Button(getBookMarkBtn) THEN
				SelectedArticle% = 0
				ArticleText = ""
				u$ = GetBookMarkUrl(BookMarkList.SelectedIndex)
				IF u$ <> "" THEN
					LoadRss (u$)
					IF NbrArticles > 0 THEN
						Draw.ItemList ListeArticles, ArticlesData()
					ELSE
						MouseHide
						LINE (wx1 + 5, wy1 + 25)-(wx2, wy2 - 5), 8, BF
					END IF
					ArticleText = ""
					Draw.MUltiLIne ArticleContent, ArticleText

				END IF
		      END IF
		      IF Click.Button(RemoveBookMarkBtn) THEN
			RemoveBookMark (BookMarkList.SelectedIndex)

		      END IF
		END IF
	END IF
LOOP

catch:
	rep = 0
RESUME NEXT

REM $STATIC
SUB DrawBookMark
	MouseHide
	Draw.Window bx1, by1 - 15, bx2, by2, Localize("rss.str", "txtBookmark")
	IF nbrBookMark > 0 THEN
		Draw.ItemList BookMarkList, BookMarkText()
		Draw.Button getBookMarkBtn
		Draw.Button RemoveBookMarkBtn
		BookMarkList.SelectedIndex = -1
		BookMarkList.SelectedText = ""
	END IF
	MouseShow
END SUB

FUNCTION GetArticle$ (filename AS STRING, num AS INTEGER)
	descr$ = ""
	fic = FREEFILE
	OPEN filename FOR INPUT AS fic
	index = 0
	WHILE (NOT EOF(fic))
	       LINE INPUT #fic, ligne$
	       IF LCASE$(LEFT$(ligne$, 5)) = "<item" THEN index = index + 1
	       initem = (index = num)
	       IF index > num THEN CLOSE fic: EXIT FUNCTION
	       IF LCASE$(LEFT$(ligne$, 13)) = "</description" THEN
		indescr = 0
		IF initem THEN
			'IF INSTR(descr$, "<div") > 0 THEN descr$ = LEFT$(descr$, INSTR(descr$, "<div") - 1)
			descr$ = RemoveTags$(descr$)
			GetArticle = descr$
			CLOSE fic
			EXIT FUNCTION
		END IF
	       END IF
	       IF LCASE$(LEFT$(ligne$, 12)) = "<description" AND initem THEN
		 indescr = -1
		 LINE INPUT #fic, ligne$
	       END IF
	       IF indescr THEN
			'i = INSTR(ligne$, "< p >")
			'IF i > 0 THEN ligne$ = LEFT$(ligne$, i - 1) + CHR$(13) + CHR$(10) + MID$(ligne$, i + 5)
			'i = INSTR(ligne$, "< /p >")
			'IF i > 0 THEN ligne$ = LEFT$(ligne$, i - 1) + MID$(ligne$, i + 6)
			descr$ = descr$ + ligne$
		END IF
		WEND
	CLOSE fic
'GetArticle = descr$
END FUNCTION

FUNCTION GetBookMarkUrl$ (num AS INTEGER)
	rep = -1
	i = 0
	OPEN "system\rss.txt" FOR INPUT AS 1
		IF rep = 0 THEN
			GetBookMarkUrl$ = ""
			EXIT FUNCTION
		END IF
		WHILE NOT (EOF(1))

			LINE INPUT #1, title$
			LINE INPUT #1, url$
			i = i + 1
			IF i = num THEN
				GetBookMarkUrl$ = url$
				CLOSE 1
				EXIT FUNCTION
			END IF
		WEND
	CLOSE 1

END FUNCTION

FUNCTION GetNbrArticles (filename AS STRING)
NbrItem = 0
fic = FREEFILE
OPEN filename FOR INPUT AS fic
	WHILE NOT EOF(fic)
		LINE INPUT #fic, ligne$
		IF LCASE$(LEFT$(ligne$, 5)) = "<item" THEN NbrItem = NbrItem + 1
	WEND
CLOSE fic
GetNbrArticles = NbrItem

END FUNCTION

SUB GetRss (url AS STRING)
	RssUrl = url
	Net.DownloadPageNoPost url, "file.xml"
	fic = FREEFILE
	ligne$ = " "
	OPEN "file.xml" FOR BINARY AS fic
	fic2 = FREEFILE
	OPEN "out.xml" FOR OUTPUT AS fic2
	text$ = ""
relire:
	WHILE NOT (EOF(fic))

		  ligne$ = " "
		  GET #fic, , ligne$
		  IF ligne$ = CHR$(195) THEN
		      GET #fic, , ligne$
		      IF ligne$ = CHR$(180) THEN ligne$ = ""
		      IF ligne$ = CHR$(170) THEN ligne$ = ""
		      IF ligne$ = CHR$(169) THEN ligne$ = ""
		      IF ligne$ = CHR$(168) THEN ligne$ = ""
		  END IF
		  IF ligne$ = "&" THEN
			car$ = ligne$
			WHILE ligne$ <> ";"
				GET #fic, , ligne$
				car$ = car$ + ligne$
			WEND
			IF car$ = "&lt;" THEN text$ = text$ + "<"
			IF car$ = "&gt;" THEN text$ = text$ + ">"
			GOTO relire
		  END IF
		  
		  IF ligne$ = "<" THEN
			IF text$ <> "" THEN PRINT #fic2, text$
			text$ = ligne$
		  ELSEIF ligne$ = ">" THEN
			text$ = text$ + ligne$
			PRINT #fic2, text$
			text$ = ""
		  ELSE
			text$ = text$ + ligne$
		  END IF
	WEND
	PRINT #fic2, text$
	CLOSE fic2
	CLOSE fic
	 KILL "file.xml"
	 RssTitle = GetTitle("out.xml", 0)
	 ArticleText = ""
	
END SUB

FUNCTION GetTitle$ (filename AS STRING, num AS INTEGER)
	title$ = ""
	fic = FREEFILE
	OPEN filename FOR INPUT AS fic
	index = 0
	WHILE (NOT EOF(fic))
	       LINE INPUT #fic, ligne$
	       IF LCASE$(LEFT$(ligne$, 5)) = "<item" THEN index = index + 1
	       initem = (index = num)
	       IF index > num THEN CLOSE fic: EXIT FUNCTION
	       IF LCASE$(LEFT$(ligne$, 7)) = "</title" THEN
		intitle = 0
		IF initem THEN
			GetTitle = title$
			CLOSE fic
			EXIT FUNCTION
		END IF
	       END IF
		IF LCASE$(LEFT$(ligne$, 6)) = "<title" AND initem THEN
		 intitle = -1
		 LINE INPUT #fic, ligne$
		END IF
		IF intitle THEN title$ = title$ + ligne$
	WEND
	CLOSE fic
GetTitle = title$
END FUNCTION

SUB LoadBookMark
	nbrBookMark = 0
	rep = -1
	OPEN "system\rss.txt" FOR INPUT AS 1
		IF rep = 0 THEN
			ERASE BookMarkText
			EXIT SUB
		END IF
		WHILE NOT (EOF(1))
			LINE INPUT #1, title$
			LINE INPUT #1, url$
			nbrBookMark = nbrBookMark + 1
		WEND
	CLOSE 1
	IF nbrBookMark = 0 THEN
		ERASE BookMarkText
		EXIT SUB
	END IF
	REDIM BookMarkText(1 TO nbrBookMark) AS ListItem
	OPEN "system\rss.txt" FOR INPUT AS 1
		FOR i = 1 TO nbrBookMark
			LINE INPUT #1, BookMarkText(i).text
			BookMarkText(i).Selected = 0
			LINE INPUT #1, url$
		NEXT i
	CLOSE 1

	
END SUB

SUB LoadRss (url AS STRING)
	GetRss (url)
	NbrArticles = GetNbrArticles("out.xml")
	IF NbrArticles > 0 THEN
		ERASE ArticlesData
		REDIM ArticlesData(1 TO NbrArticles) AS ListItem
		FOR i% = 1 TO NbrArticles
			ArticlesData(i%).text = GetTitle("out.xml", i%)
		NEXT i%
	ELSE
		ERASE ArticlesData
	END IF
END SUB

SUB RemoveBookMark (num AS INTEGER)
	i = 0
	OPEN "system\rss.txt" FOR INPUT AS 1
	OPEN "system\rss.tmp" FOR OUTPUT AS 2
		IF rep = 0 THEN
			EXIT SUB
		END IF
		WHILE NOT (EOF(1))

			LINE INPUT #1, title$
			LINE INPUT #1, url$
			i = i + 1
			IF i <> num THEN
				PRINT #2, title$
				PRINT #2, url$
			END IF
		WEND
	CLOSE 2
	CLOSE 1
	KILL "system\rss.txt"
	NAME "system\rss.tmp" AS "system\rss.txt"
	LoadBookMark
	DrawBookMark

END SUB

FUNCTION RemoveTags$ (text AS STRING)
	i = INSTR(text, "<")
	j = INSTR(MID$(text, i + 1), ">")
	IF j > 0 THEN j = j + i
	WHILE (j > i)
		IF i > 1 THEN
			gauche$ = LEFT$(text$, i - 1)
		ELSE
			gauche$ = ""
		END IF

		IF j < LEN(text) THEN
			droite$ = MID$(text$, j + 1)
		ELSE
			droite$ = ""
		END IF
		text = gauche$ + droite$
		i = INSTR(text, "<")
		j = INSTR(MID$(text, i + 1), ">")
		IF j > 0 THEN j = j + i

	WEND
	RemoveTags$ = text
END FUNCTION

SUB SaveBookMark (url AS STRING, title AS STRING)
	OPEN "system\rss.txt" FOR APPEND AS 1
		PRINT #1, title
		PRINT #1, url
	CLOSE 1
	LoadBookMark
	DrawBookMark
END SUB

SUB xml

NbrItem = 0
OPEN "out.tmp" FOR INPUT AS fic
	WHILE NOT EOF(fic)
		LINE INPUT #fic, ligne$
		IF LCASE$(LEFT$(ligne$, 5)) = "<item" THEN NbrItem = NbrItem + 1
	WEND
CLOSE fic
PRINT txtNumitems; NbrItem
DO
	PRINT txtEnternum
	INPUT num$
	IF num$ = "" THEN EXIT DO
	index = VAL(num$)
	GOSUB ShowItem
	PRINT title$
	IF INSTR(descr$, ";") > 0 THEN descr$ = LEFT$(descr$, INSTR(descr$, ";") - 1)
	PRINT descr$
	'END IF

LOOP

END


ShowItem:
	title$ = ""
	descr$ = ""
	OPEN "out.tmp" FOR INPUT AS fic
	continue = 1
	lindex = 0
	WHILE (NOT EOF(fic)) AND (continue = 1)
	       LINE INPUT #fic, ligne$
	       IF LCASE$(LEFT$(ligne$, 5)) = "<item" THEN lindex = lindex + 1
	       IF lindex = index THEN
		initem = -1
	       ELSE
		initem = 0
	       END IF
	       IF lindex > index THEN CLOSE fic: EXIT SUB
	       IF LCASE$(LEFT$(ligne$, 7)) = "</title" THEN intitle = 0
	       IF LCASE$(LEFT$(ligne$, 6)) = "<title" AND initem THEN
		intitle = -1
		LINE INPUT #fic, ligne$
	       END IF
	       IF intitle THEN title$ = title$ + ligne$
	     
	       IF LCASE$(LEFT$(ligne$, 13)) = "</description" THEN indescr = 0
	       IF LCASE$(LEFT$(ligne$, 12)) = "<description" AND initem THEN
		indescr = -1
		LINE INPUT #fic, ligne$
	       END IF
	       IF indescr THEN descr$ = descr$ + ligne$


	WEND
	CLOSE fic
EXIT SUB


END SUB

